/*------------------------------------------------------------------------.
| Copyright (C) 1997,1998,2000 Alexandre Duret-Lutz <duret_g@epita.fr>    |
|                                                                         |
| This file is part of Heroes.                                            |
|                                                                         |
| Heroes is free software; you can redistribute it and/or modify it under |
| the terms of the GNU General Public License as published by the Free    |
| Software Foundation; either version 2 of the License, or (at your       |
| option) any later version.                                              |
|                                                                         |
| Heroes is distributed in the hope that it will be useful, but WITHOUT   |
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or   |
| FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License   |
| for more details.                                                       |
|                                                                         |
| You should have received a copy of the GNU General Public License along |
| with this program; if not, write to the Free Software Foundation, Inc., |
| 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   |
`------------------------------------------------------------------------*/

/* $Id: const.c 1.13 Sat, 20 May 2000 18:37:42 +0200 pollux $ */

/* constantes d'Heroes ... */

#include <stdio.h>
#include "stdlib.h"
#include "keyb.h"
#include "joystick.h"
#include "pcx.h"
#include "keymap.h"
#include "sfx.h"
#include "structs.h"
#include "options.h"
#include "display.h"
#include "const.h"
#include "timer.h"

// Def. des 15 sprites de l'explosion1,  l'envers (14->0).
#define nfrexplo1 15
int fst_explo_list[nfrexplo1] = { 132 + 65 * 320,
  99 + 65 * 320,
  66 + 65 * 320,
  33 + 65 * 320,
  65 * 320,
  264 + 32 * 320,
  231 + 32 * 320,
  198 + 32 * 320,
  165 + 32 * 320,
  132 + 32 * 320,
  99 + 32 * 320,
  66 + 32 * 320,
  33 + 32 * 320,
  32 * 320
};
int snd_explo_list[nfrexplo1] = { 132 + 131 * 320,
  99 + 131 * 320,
  66 + 131 * 320,
  33 + 131 * 320,
  131 * 320,
  264 + 98 * 320,
  231 + 98 * 320,
  198 + 98 * 320,
  165 + 98 * 320,
  132 + 98 * 320,
  99 + 98 * 320,
  66 + 98 * 320,
  33 + 98 * 320,
  98 * 320
};

int trail[16] =
  { 110 * 192, 0, 0, 30 * 192, 100 * 192, 20 * 192, 70 * 192, 0, 0, 10 * 192,
  80 * 192, 40 * 192, 90 * 192, 0, 60 * 192, 50 * 192
};

/* correspondance entree-output pour les virages de tunnels, je sais plus
   comment a marche, mais a marche... */
int tunnel_square_io[4][2] = { {0, 1}, {1, 3}, {3, 2}, {2, 0} };

#define xbuf 384		// pour des multiplications plus faciles
#define ybuf 300		// une bande vide de 50 lignes au dessus et en dessous...
#define sbuf 50*xbuf		// ...pour viter de faire du clipping sur les explosions

#define NOGLENZPLR 108		// colors pour les traines sans glenz
#define NOGLENZRED 16		// couleur pour le sang sans glenz

char radar_trail_color[16] =
  { 111, 127, 143, 159, 111, 127, 143, 159, 109, 125, 141, 157, 109, 125, 141,
  157
};
char radar_wall_color[16] =
  { 0, 89, 89, 91, 89, 91, 91, 93, 89, 91, 91, 93, 91, 93, 93, 95 };

//                     L+  L-  S+  S-  R#   C  ZZ  !!  -1  T+  T-  EL  []   X  XL  ~~  $$
int bonus_proba_array[5][17] =
  { {40, 10, 12, 8, 8, 40, 0, 8, 10, 16, 16, 0, 8, 7, 4, 7, 0},	//quest
{0, 0, 10, 7, 7, 20, 0, 8, 10, 10, 11, 0, 6, 7, 2, 7, 0},	//deathm
{25, 10, 12, 8, 8, 40, 0, 8, 10, 16, 16, 0, 8, 7, 4, 7, 0},	//killem
{25, 10, 12, 8, 8, 20, 0, 8, 10, 16, 16, 0, 8, 7, 4, 7, 25},	//tcash
{25, 10, 12, 8, 8, 30, 0, 8, 10, 16, 16, 0, 8, 7, 4, 7, 0}
};				//color
int bonus_points[2][17] =
  { {20, -15, 15, -10, 5, 18, 0, -10, 0, 0, -5, 50, 5, 0, 8, 0, 25},	//violets
{-15, 10, 0, 10, 5, -5, 0, 8, 8, -5, 5, -20, -5, 9, -10, 9, -25}
};				//beiges

/* differentes possibilits pour le nbr de rounds */
int rounds_nbr_values[16] =
  { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 15, 20, 30, 50, 100 };

int square_offset_320[4] = { 0, 12, 320 * 10, 320 * 10 + 12 };
int square_offset[4] = { 0, 12, xbuf * 10, xbuf * 10 + 12 };

char mode_name[5][12] = { "QUEST", "DEATH MATCH", "KILL'EM ALL",
  "TIME CA$H", "COLORS"
};

/* traductions way<->directions */
int d2w[9] = { 0, 0, 1, 1, 2, 2, 2, 2, 3 };
int w2d[4] = { d_up, d_right, d_down, d_left };

char in_menu = 1;
char in_demo = 0;
//int error;
char in_jokebox;

int frame_cur;
int frame_old;

signed char p;
signed int p2;


char kbjoy[6] = { 0, 0, 0, 0, 0, 0 };
char kbjoyold[6] = { 0, 0, 0, 0, 0, 0 };
palette_ temppal;

long int camera_x[2];		// virgule fixe 16b,16b
long int camera_y[2];		// idem
long int corner_x[2];		// en pixels
long int corner_y[2];		// idem
char *(corner[2]);		// addresse absolue
long int corner_dx[2];		// coordones de dalle
long int corner_dy[2];		// idem
long int inert_x[2], inert_y[2];
unsigned char nbr_tiles_cols = 15;	// nbr de colonnes de tile_set_img  afficher
unsigned char nbr_tiles_rows = 11;	//     ... lignes ...
char camera_stop_x[2];
char camera_stop_y[2];

char *(render_buffer[2]);	// BUFFERS DE RENDU 384*260

char glenz[8][256];		/* lignes de glenz */

level_header_t map_info = { 0, 0, -1, -1 };
int map_info_2xt, map_info_2yt, map_info_2xwrap, map_info_2ywrap;
palette_ pal;

image_ main_font_img, icons_img, vehicles_img, trailimg, bonus_a_img,
  bonus_b_img, bonus_font_img, jukebox_img;
image_ tile_set_img;

char tmp1[512];
char tmp2[512];

signed char minisinus[32];
char two_players = 0;

/****** JOUEURS ET TRAINEE ******/
#define maxq 128
// maxq  reporter dans const.h !!!
player_t player[4];
int trail_pos[4][maxq];
char trail_way[4][maxq];
int trail_offset[4];
char trail_size[4];		// Taille de la traine MOINS UN
/*******************************/

/* correspondance couleur<->player_t */
int col2plr[4];
int plr2col[4];

/****** STOCKAGE DU LEVEL ******/

tile_t *level_map;		// pointeur sur le level_map du niveau

int last_explo;

unsigned char *square_occupied;
unsigned char *square_way;
unsigned char *square_radar_wall;
unsigned char *square_wall;
unsigned char *square_explosion;
int *square_dead_explosion;
unsigned char **explo_list_ptr;
int *explo_list_pos_x;
int *explo_list_pos_y;
int explo_nbr;
unsigned char *square_explosion_type;
unsigned char *tile_bonus;
unsigned char *tile_bonus_cpu;
int *square2tile;
int *bonus_time;
unsigned char **bonus_ptr;
int *square_wrap;
int *square_offset2coord;
signed char *square_object;
#define lemmings_per_players 50
#define lemmings_total (lemmings_per_players*4)
// constantes  reporter dans const.c
lemming_t **square_lemmings_list;
lemming_t **square_dead_lemmings_list;
lemming_t lemmings_support[lemmings_total];
int bonus_total_nbr, bonus_real_nbr, objects_nbr;
int next_bonus_to_update;
int square2offset[4] = { 0, 1, 0, 0 };	/*deux dernires valeurs calcules plus tard */

int bonus_anim_offset;
int radar_target_pos;
int radar_current_pos;

int game_mode = 0;
//char questmode=0;
unsigned char game_magic;
int camera_center_x = 873813;
char *clock_anim_offset;
int lemmings_anim_offset;
int lemmings_move_offset;

char invincible[4];


void
vsynch (void)
{
  vsynchro ();
  frame_cur = update_timer_block (frame_cur);
}

void
pal2pal (palette_ * src, palette_ * dest, char step)
{				// 0  64
  int i;
  for (i = 767; i >= 0; i--)
    temppal.global[i] =
      (unsigned
       char) (((src->global[i] * (64 - step)) +(dest->global[i] * step)) >>
	      6);
}

char demo_ready = 0;
char demo_done = 0;

char
key_or_joy_ready (void)
{
  int i;
#define sleeping (70*60)
  static int lastframe = sleeping;

  if (demo_done) {
    lastframe = sleeping;
    demo_done = 0;
  }
  if ((in_jokebox == 0)) {
    lastframe--;
    if (lastframe < 70 * 30)
      demo_ready = 1;
    else
      demo_ready = 0;
    if (lastframe == 0) {
      if (in_menu)
	event_sfx (118 + (rand () & 1));
      lastframe = sleeping;
    }
  }

  if (key_ready ()) {
    lastframe = sleeping;
    return (1);
  }
  if ((joystick_detected & 1) && (opt.ctrl_one == 1 || opt.ctrl_two == 1)) {
    for (i = 0; i < 6; i++)
      kbjoyold[i] = kbjoy[i];
    joystick_x[0] = 0;
    joystick_y[0] = 0;
    get_joystick_state ();
    if (joystick_x[0] == 0 && joystick_x[0] == 0) {
      opt.ctrl_one = 0;
      opt.ctrl_two = 0;
      return (0);
    }
    kbjoy[0] = is_joystick_up (0);
    kbjoy[1] = is_joystick_right (0);
    kbjoy[2] = is_joystick_down (0);
    kbjoy[3] = is_joystick_left (0);
    kbjoy[4] = is_joystick_button_a (0);
    kbjoy[5] = is_joystick_button_b (0);
    if ((kbjoy[0] && !kbjoyold[0])
	|| (kbjoy[1] && !kbjoyold[1])
	|| (kbjoy[2] && !kbjoyold[2])
	|| (kbjoy[3] && !kbjoyold[3])
	|| (kbjoy[4] && !kbjoyold[4])
	|| (kbjoy[5] && !kbjoyold[5])) {
      lastframe = sleeping;
      return (1);
    }
  }
  return (0);
}

int
get_key_or_joy (void)
{
  if (key_ready ())
    return (get_key ());
  if (kbjoy[0] && !kbjoyold[0])
    return (0x4800);
  if (kbjoy[1] && !kbjoyold[1])
    return (0x4D00);
  if (kbjoy[2] && !kbjoyold[2])
    return (0x5000);
  if (kbjoy[3] && !kbjoyold[3])
    return (0x4B00);
  if (kbjoy[4] && !kbjoyold[4])
    return (0x1C0D);
  if (kbjoy[5] && !kbjoyold[5])
    return (0x011B);
  printf ("erreur dans get_key_or_joy()");
  return (0);
}

void
draw_glenz_box (unsigned char *dest, int c, int xt, int yt)
{
  char *glenzligne = glenz[c];
  int xt2;

  for (; yt != 0; yt--) {
    for (xt2 = xt; xt2 != 0; xt2--)
      *dest++ = glenzligne[*dest];
    dest += xbuf - xt;
  }

}

void
set_pal_with_luminance (palette_ * palsrc)
{
  palette_ paldest;
  int i;
  if (opt.luminance == 3) {
    set_pal ((char *) palsrc, 0, 768);
    return;
  }
  if (opt.luminance < 3) {
    for (i = 767; i >= 0; i--)
      paldest.global[i] =
	(unsigned
	 char) ((palsrc->global[i] * (64 - (3 - opt.luminance) * 6) +
		 64 * 6 * (3 - opt.luminance)) >>6);
  } else if (opt.luminance > 3) {
    for (i = 767; i >= 0; i--)
      paldest.global[i] = (unsigned char) ((palsrc->global[i] * 64)
					   /(64 + (opt.luminance - 3) * 6));
//  ((src->global[i]*(64-step))+(dest->global[i]*step))>>6;
  }
  set_pal ((char *) &paldest, 0, 768);
}
