/*------------------------------------------------------------------------.
| Copyright (C) 1997,1998,2000 Alexandre Duret-Lutz <duret_g@epita.fr>    |
|                                                                         |
| This file is part of Heroes.                                            |
|                                                                         |
| Heroes is free software; you can redistribute it and/or modify it under |
| the terms of the GNU General Public License as published by the Free    |
| Software Foundation; either version 2 of the License, or (at your       |
| option) any later version.                                              |
|                                                                         |
| Heroes is distributed in the hope that it will be useful, but WITHOUT   |
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or   |
| FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License   |
| for more details.                                                       |
|                                                                         |
| You should have received a copy of the GNU General Public License along |
| with this program; if not, write to the Free Software Foundation, Inc., |
| 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   |
`------------------------------------------------------------------------*/

/* $Id: extras.c 1.9 Sat, 20 May 2000 18:04:05 +0200 pollux $ */

/*
*   Cration de la liste des niveaux supplmentaires.
*/

#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include "extras.h"
#include "config.h"

char **extra_list;

char *extra_selected_list;

int extra_nbr = 0;

static int
select_file (const struct dirent *d)
{
  int l = strlen (d->d_name);
  return (l > 4 && d->d_name[l - 4] == '.' && d->d_name[l - 3] == 'l'
	  && d->d_name[l - 2] == 'v' && d->d_name[l - 1] == 'l');
}

void
make_extra_list (void)
{
  int i;
  struct dirent **tmp_list;

  extra_nbr = scandir (extradir, &tmp_list, select_file, alphasort);
  extra_selected_list = malloc (extra_nbr /* + 1 */ );
  memset (extra_selected_list, 0, extra_nbr /* + 1 */ );
  extra_list = malloc (extra_nbr * sizeof (*extra_list));
  for (i = 0; i < extra_nbr; ++i) {
    extra_list[i] = strdup (tmp_list[i]->d_name);
    free (tmp_list[i]);
  }
  free (tmp_list);
}
