/*------------------------------------------------------------------------.
| Copyright (C) 1997,1998,2000 Alexandre Duret-Lutz <duret_g@epita.fr>    |
|                                                                         |
| This file is part of Heroes.                                            |
|                                                                         |
| Heroes is free software; you can redistribute it and/or modify it under |
| the terms of the GNU General Public License as published by the Free    |
| Software Foundation; either version 2 of the License, or (at your       |
| option) any later version.                                              |
|                                                                         |
| Heroes is distributed in the hope that it will be useful, but WITHOUT   |
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or   |
| FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License   |
| for more details.                                                       |
|                                                                         |
| You should have received a copy of the GNU General Public License along |
| with this program; if not, write to the Free Software Foundation, Inc., |
| 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   |
`------------------------------------------------------------------------*/

/* $Id: joystick.c 1.7 Sat, 20 May 2000 18:04:05 +0200 pollux $ */

#include "joystick.h"

unsigned int joystick_x[2];	// coord. X
unsigned int joystick_y[2];	//        Y
char joystick_b[2];		// boutons (sur 2bits)
char joystick_detected = 0;	// 0=aucun,3=1er,12=2nd,15=les deux

 /* limites  partir desquelles on considre le joy dans une position */

unsigned int joystick_limit_up[2];
unsigned int joystick_limit_right[2];
unsigned int joystick_limit_down[2];
unsigned int joystick_limit_left[2];

static void
_get_joystick_state (char x)
{				/* FIXME: JOY */
}

/* joyinit() detecte les joy prsents et vite les tests ulterieurs */
char
joyinit (void)
{
  _get_joystick_state (0xff);
  if (joystick_x[0] || joystick_y[0])
    joystick_detected |= 3;
  if (joystick_x[1] || joystick_y[1])
    joystick_detected |= 12;

	/**** calcul des seuils *****/
  joystick_limit_down[0] = (joystick_limit_up[0] = joystick_y[0] / 2) * 3;
  joystick_limit_right[0] = (joystick_limit_left[0] = joystick_x[0] / 2) * 3;
  joystick_limit_down[1] = (joystick_limit_up[1] = joystick_y[1] / 2) * 3;
  joystick_limit_right[1] = (joystick_limit_left[1] = joystick_x[1] / 2) * 3;

  return (joystick_detected);
}

/* lit l'tat du joystick, a appeller avant chaque test en "is"... */
//#define get_joystick_state() if (joystick_detected) _get_joystick_state(joystick_detected)
void
get_joystick_state (void)
{
  if (joystick_detected)
    _get_joystick_state (joystick_detected);
}

/* diferents tests de position de joystick*/
#define is_joystick_up(j)    (joystick_y[j]<joystick_limit_up[j])
#define is_joystick_down(j)  (joystick_y[j]>joystick_limit_down[j])
#define is_joystick_left(j)  (joystick_x[j]<joystick_limit_left[j])
#define is_joystick_right(j) (joystick_x[j]>joystick_limit_right[j])
#define is_joystick_button_a(j)  (joystick_b[j]&1)
#define is_joystick_button_b(j)  (joystick_b[j]&2)
