/*------------------------------------------------------------------------.
| Copyright (C) 1997,1998,2000 Alexandre Duret-Lutz <duret_g@epita.fr>    |
|                                                                         |
| This file is part of Heroes.                                            |
|                                                                         |
| Heroes is free software; you can redistribute it and/or modify it under |
| the terms of the GNU General Public License as published by the Free    |
| Software Foundation; either version 2 of the License, or (at your       |
| option) any later version.                                              |
|                                                                         |
| Heroes is distributed in the hope that it will be useful, but WITHOUT   |
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or   |
| FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License   |
| for more details.                                                       |
|                                                                         |
| You should have received a copy of the GNU General Public License along |
| with this program; if not, write to the Free Software Foundation, Inc., |
| 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   |
`------------------------------------------------------------------------*/

/* $Id: keyb.c 1.10 Sat, 20 May 2000 18:37:42 +0200 pollux $ */

#include <stdio.h>
#include <stdlib.h>
#include <ggi/ggi.h>
#include <assert.h>
#include "keymap.h"
#include "keysdef.h"		// utilis pour KB_PAUSE

#include "keyb.h"

unsigned char keyboard_map[KEY_MAX + 1];

extern ggi_visual_t visu;

void
init_keyboard_map (void)
{
  int i;

  for (i = KEY_MAX; i >= 0; i--)
    keyboard_map[i] = 0;

  //  ggiSetEventMask(visu, emKeyPress|emKeyRelease);

}

void
process_input_events (void)
{
  struct timeval t = { 0, 0 };

  if (ggiEventPoll (visu, emKeyPress | emKeyRelease | emKeyRepeat, &t) 
      != emZero) {
    int nbr;
    ggi_event ev;

    nbr = ggiEventsQueued (visu, emKeyPress | emKeyRelease | emKeyRepeat);
    for (; nbr; --nbr) {
      ggiEventRead (visu, &ev, emKeyPress | emKeyRelease | emKeyRepeat);
      if (ev.any.type == evKeyPress) {
	assert (ev.key.button <= KEY_MAX);
	keyboard_map[ev.key.button] = 1;
      } else if (ev.any.type == evKeyRelease) {
	assert (ev.key.button <= KEY_MAX);
	keyboard_map[ev.key.button] = 0;
      } else if (ev.any.type == evKeyRepeat) {
	/* NOP */
      } else {
	printf ("unexpected event %d\n", ev.any.type);
      }
    }
  }
}

void
uninit_keyboard_map (void)
{
}
