/*------------------------------------------------------------------------.
| Copyright (C) 1997,1998,2000 Alexandre Duret-Lutz <duret_g@epita.fr>    |
|                                                                         |
| This file is part of Heroes.                                            |
|                                                                         |
| Heroes is free software; you can redistribute it and/or modify it under |
| the terms of the GNU General Public License as published by the Free    |
| Software Foundation; either version 2 of the License, or (at your       |
| option) any later version.                                              |
|                                                                         |
| Heroes is distributed in the hope that it will be useful, but WITHOUT   |
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or   |
| FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License   |
| for more details.                                                       |
|                                                                         |
| You should have received a copy of the GNU General Public License along |
| with this program; if not, write to the Free Software Foundation, Inc., |
| 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   |
`------------------------------------------------------------------------*/

/* $Id: keysdef.h 1.3 Sat, 20 May 2000 18:04:05 +0200 pollux $ */

#ifndef _KEYSDEF_H_plx_
#define _KEYSDEF_H_plx_

#define KB_ESC          1
#define KB_TOP1         2
#define KB_TOP2         3
#define KB_TOP3         4
#define KB_TOP4         5
#define KB_TOP5         6
#define KB_TOP6         7
#define KB_TOP7         8
#define KB_TOP8         9
#define KB_TOP9         10
#define KB_TOP10        11
#define KB_TOPMOINS     12
#define KB_TOPPLUS      13
#define KB_BKSPC        14
#define KB_TAB          15
#define KB_Q            16
#define KB_W            17
#define KB_E            18
#define KB_R            19
#define KB_T            20
#define KB_Y            21
#define KB_U            22
#define KB_I            23
#define KB_O            24
#define KB_P            25
#define KB_CG           26
#define KB_CD           27
#define KB_RETURN       28
#define KB_CTRLG        29
#define KB_A            30
#define KB_S            31
#define KB_D            32
#define KB_F            33
#define KB_G            34
#define KB_H            35
#define KB_J            36
#define KB_K            37
#define KB_L            38
#define KB_2PTS         39
#define KB_TICK         40
#define KB_BSLH         41
#define KB_SHG          42
#define KB_VIRG         43
#define KB_Z            44
#define KB_X            45
#define KB_C            46
#define KB_V            47
#define KB_B            48
#define KB_N            49
#define KB_M            50
#define KB_INF          51
#define KB_SUP          52
#define KB_INTERO       53
#define KB_SHD          54
#define KB_PADMUL       55
#define KB_ALTG         56
#define KB_SPC          57
#define KB_CAPSLOCK     58
#define KB_F1           59
#define KB_F2           60
#define KB_F3           61
#define KB_F4           62
#define KB_F5           63
#define KB_F6           64
#define KB_F7           65
#define KB_F8           66
#define KB_F9           67
#define KB_F10          68
#define KB_NUMLOCK      69
#define KB_ARRETDEF     70
#define KB_PAD7         71
#define KB_PAD8         72
#define KB_PAD9         73
#define KB_PADMOINS     74
#define KB_PAD4         75
#define KB_PAD5         76
#define KB_PAD6         77
#define KB_PADPLUS      78
#define KB_PAD1         79
#define KB_PAD2         80
#define KB_PAD3         81
#define KB_PAD0         82
#define KB_PADPT        83
#define KB_F11          87
#define KB_F12          88
#define KB_PADRETURN    156
#define KB_CTRLD        157
#define KB_PADDIV       181
#define KB_IMPRECR      183
#define KB_ALTD         184
#define KB_HOME         199
#define KB_HAUT         200
#define KB_PGUP         201
#define KB_GAUCHE       203
#define KB_DROITE       205
#define KB_END          207
#define KB_BAS          208
#define KB_PGDN         209
#define KB_INS          210
#define KB_DEL          211
#define KB_WING         219
#define KB_WINM         220
#define KB_WINR         221
#define KB_PAUSE        225	/* librement dplaable */

#endif

#ifdef KEYSDEFTAB
//  dfinir avant d'inclure KEYSDEF.H pour avoir le tableau suivant.
#ifndef _KEYSDEFTAB_plx_
char key_string[256][5] = {
  "",				//00
  "ESC",			//01
  "TOP1",			//02
  "TOP2",			//03
  "TOP3",			//04
  "TOP4",			//05
  "TOP5",			//06
  "TOP6",			//07
  "TOP7",			//08
  "TOP8",			//09
  "TOP9",			//10
  "TOP0",			//11
  "TOP-",			//12
  "TOP+",			//13
  "BKSP",			//14
  "TAB",			//15
  "Q",				//16
  "W",				//17
  "E",				//18
  "R",				//19
  "T",				//20
  "Y",				//21
  "U",				//22
  "I",				//23
  "O",				//24
  "P",				//25
  "[",				//26
  "]",				//27
  "RETN",			//28
  "CTRL",			//29
  "A",				//30
  "S",				//31
  "D",				//32
  "F",				//33
  "G",				//34
  "H",				//35
  "J",				//36
  "K",				//37
  "L",				//38
  ":",				//39
  "TICK",			//40
  "",				//41
  "SHL",			//42
  "BSLH",			//43
  "Z",				//44
  "X",				//45
  "C",				//46
  "V",				//47
  "B",				//48
  "N",				//49
  "M",				//50
  "<",				//51
  ">",				//52
  "?",				//53
  "SHR",			//54
  "NUM*",			//55
  "ALTL",			//56
  "SPC",			//57
  "CLCK",			//58
  "F1",				//59
  "F2",				//60
  "F3",				//61
  "F4",				//62
  "F5",				//63
  "F6",				//64
  "F7",				//65
  "F8",				//66
  "F9",				//67
  "F10",			//68
  "NLCK",			//69
  "SLCK",			//70
  "NUM7",			//71
  "NUM8",			//72
  "NUM9",			//73
  "NUM-",			//74
  "NUM4",			//75
  "NUM5",			//76
  "NUM6",			//77
  "NUM+",			//78
  "NUM1",			//79
  "NUM2",			//80
  "NUM3",			//81
  "NUM0",			//82
  "NUM.",			//83
  "",				//84
  "",				//85
  "\\",				//86
  "F11",			//87
  "F12",			//88
  "",				//89
  "",				//90
  "",				//91
  "",				//92
  "",				//93
  "",				//94
  "",				//95
  "",				//96
  "",				//97
  "",				//98
  "",				//99
  "",				//100
  "",				//101
  "",				//102
  "",				//103
  "",				//104
  "",				//105
  "",				//106
  "",				//107
  "",				//108
  "",				//109
  "",				//110
  "",				//111
  "",				//112
  "",				//113
  "",				//114
  "",				//115
  "",				//116
  "",				//117
  "",				//118
  "",				//119
  "",				//120
  "",				//121
  "",				//122
  "",				//123
  "",				//124
  "",				//125
  "",				//126
  "",				//127
  "",				//128
  "",				//129
  "",				//130
  "",				//131
  "",				//132
  "",				//133
  "",				//134
  "",				//135
  "",				//136
  "",				//137
  "",				//138
  "",				//139
  "",				//140
  "",				//141
  "",				//142
  "",				//143
  "",				//144
  "",				//145
  "",				//146
  "",				//147
  "",				//148
  "",				//149
  "",				//150
  "",				//151
  "",				//152
  "",				//153
  "",				//154
  "",				//155
  "NRTN",			//156
  "CTRR",			//157
  "",				//158
  "",				//159
  "",				//160
  "",				//161
  "",				//162
  "",				//163
  "",				//164
  "",				//165
  "",				//166
  "",				//167
  "",				//168
  "",				//169
  "",				//170
  "",				//171
  "",				//172
  "",				//173
  "",				//174
  "",				//175
  "",				//176
  "",				//177
  "",				//178
  "",				//179
  "",				//180
  "NUM/",			//181
  "",				//182
  "PRSC",			//183
  "ALTR",			//184
  "",				//185
  "",				//186
  "",				//187
  "",				//188
  "",				//189
  "",				//190
  "",				//191
  "",				//192
  "",				//193
  "",				//194
  "",				//195
  "",				//196
  "",				//197
  "",				//198
  "HOME",			//199
  "UP",				//200
  "PGUP",			//201
  "",				//202
  "LEFT",			//203
  "",				//204
  "RGHT",			//205
  "",				//206
  "END",			//207
  "DOWN",			//208
  "PGDN",			//209
  "INS",			//210
  "DEL",			//211
  "",				//212
  "",				//213
  "",				//214
  "",				//215
  "",				//216
  "",				//217
  "",				//218
  "WINL",			//219
  "WINM",			//220
  "WINR",			//221
  "",				//222
  "",				//223
  "",				//224
  "STOP",			//225   dplacer en fonction de KB_PAUSE
  "",				//226
  "",				//227
  "",				//228
  "",				//229
  "",				//230
  "",				//231
  "",				//232
  "",				//233
  "",				//234
  "",				//235
  "",				//236
  "",				//237
  "",				//238
  "",				//239
  "",				//240
  "",				//241
  "",				//242
  "",				//243
  "",				//244
  "",				//245
  "",				//246
  "",				//247
  "",				//248
  "",				//249
  "",				//250
  "",				//251
  "",				//252
  "",				//253
  "",				//254
  ""
};				//255
#endif
#endif
