/*------------------------------------------------------------------------.
| Copyright (C) 1997,1998,2000 Alexandre Duret-Lutz <duret_g@epita.fr>    |
|                                                                         |
| This file is part of Heroes.                                            |
|                                                                         |
| Heroes is free software; you can redistribute it and/or modify it under |
| the terms of the GNU General Public License as published by the Free    |
| Software Foundation; either version 2 of the License, or (at your       |
| option) any later version.                                              |
|                                                                         |
| Heroes is distributed in the hope that it will be useful, but WITHOUT   |
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or   |
| FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License   |
| for more details.                                                       |
|                                                                         |
| You should have received a copy of the GNU General Public License along |
| with this program; if not, write to the Free Software Foundation, Inc., |
| 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   |
`------------------------------------------------------------------------*/

/* $Id: options.c 1.7 Sat, 20 May 2000 18:04:05 +0200 pollux $ */

/* chargement, et reinitialisation des options d'Heroes */

#include "optionss.h"
#include "stdio.h"
#include "options.h"
#include "config.h"

options_t opt;
char extrasel = 0;

void
write_options (void)
{
  FILE *fs;
  fs = fopen (confdir "options.dat", "wb");
  fwrite (&opt, 1, sizeof (opt), fs);
  fclose (fs);
}

void
reinit_options (void)
{
  opt.screen_size = 0;		// 0=max
  opt.radar_map = 1;
  opt.use_glenz = 1;
  opt.display_infos = 1;
  opt.luminance = 3;
  opt.inertia = 1;
  opt.music = 1;
  opt.music_volume = 6;		// 0=max
  opt.sfx = 1;
  opt.sfx_volume = 6;		// 0=max
  opt.ctrl_one = 0;		// 0=keyboard_map
  opt.ctrl_two = 0;		// 1=joystick
  opt.autopilot_one = 1;
  opt.autopilot_two = 1;
  opt.ghosts = 0;
  opt.speed = 0;
  opt.gamerounds = 4;
  opt.player_color[0] = 0;
  opt.player_color[1] = 1;
  opt.player_color[2] = 2;
  opt.player_color[3] = 3;
  opt.player_keys[0][0] = 72;
  opt.player_keys[0][1] = 75;
  opt.player_keys[0][2] = 80;
  opt.player_keys[0][3] = 77;
  opt.player_keys[0][4] = 157;
  opt.player_keys[0][5] = 54;
  opt.player_keys[1][0] = 17;
  opt.player_keys[1][1] = 30;
  opt.player_keys[1][2] = 44;
  opt.player_keys[1][3] = 32;
  opt.player_keys[1][4] = 29;
  opt.player_keys[1][5] = 42;
  opt.extras = 0;
}

void
load_options (void)
{
  FILE *fs;
  fs = fopen (confdir "options.dat", "rb");
  if (fs == NULL)
    reinit_options ();
  else {
    if (fread (&opt, 1, sizeof (opt), fs) != sizeof (opt))
      reinit_options ();
    fclose (fs);
  }
}
