/*------------------------------------------------------------------------.
| Copyright (C) 1997,1998,2000 Alexandre Duret-Lutz <duret_g@epita.fr>    |
|                                                                         |
| This file is part of Heroes.                                            |
|                                                                         |
| Heroes is free software; you can redistribute it and/or modify it under |
| the terms of the GNU General Public License as published by the Free    |
| Software Foundation; either version 2 of the License, or (at your       |
| option) any later version.                                              |
|                                                                         |
| Heroes is distributed in the hope that it will be useful, but WITHOUT   |
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or   |
| FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License   |
| for more details.                                                       |
|                                                                         |
| You should have received a copy of the GNU General Public License along |
| with this program; if not, write to the Free Software Foundation, Inc., |
| 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   |
`------------------------------------------------------------------------*/

/* $Id: scores.c 1.7 Sat, 20 May 2000 18:37:42 +0200 pollux $ */

/* sauvegarde des scores d'Heroes */

#include "structs.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "scores.h"
#include "config.h"

top_score highs[5][10];

static int
cmp_scores (const void *r1, const void *r2)
{				/*top_score * r1=c1;
				   top_score * r2=c2; */
  return (((top_score *) r2)->points - ((top_score *) r1)->points);
}

void
sort_scores (void)
{
  int i;
  for (i = 0; i < 5; i++)
    qsort (highs[i], 10, sizeof (top_score), cmp_scores);
}

void
clear_scores (void)
{
  int i, j;
  for (i = 0; i < 5; i++)
    for (j = 0; j < 10; j++) {
      strncpy (highs[i][j].name, "\0", 8);
      highs[i][j].magic = 0;
      highs[i][j].unused1 = 0;
      highs[i][j].unused2 = 0;
      highs[i][j].points = (10 - j) * 250;
    }
}

static unsigned long int
check_scores (void)
{
  unsigned long int crc = 0xa8c4d602;
  int i;
  char *src = (char *) highs;
  for (i = 0; i < (5 * 10 * sizeof (top_score) - 4); i += 3, src += 3)
    crc ^= *(int *) src;
  return (crc);
}

void
write_scores (void)
{
  FILE *fs;
  unsigned int i;
  fs = fopen (scoresdir "scores.dat", "wb");
  i = check_scores ();
  fwrite (highs, sizeof (top_score), 50, fs);
  fwrite ((int *) &i, 4, 1, fs);
  fclose (fs);
}

void
load_scores (void)
{
  FILE *fs;
  unsigned long int i;
  fs = fopen (scoresdir "scores.dat", "rb");
  if (fs == NULL)
    clear_scores ();
  else {
    fread (highs, sizeof (top_score), 50, fs);
    fread ((int *) &i, 4, 1, fs);
    fclose (fs);
    if (check_scores () != i)
      clear_scores ();

  }
}
